# IBM Confidential
# OCO Source Materials
# Rational ClearCase
# (C) Copyright IBM Corp. 1999, 2006
#
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#
# Various paths that may change for different platforms and installations.
#

if ($ENV{'CLEARCASEHOME'}){
    $atria_home = $ENV{CLEARCASEHOME};
}elsif($ENV{'ATRIAHOME'}){
    $atria_home = $ENV{ATRIAHOME};
}else{
    $atria_home = '/opt/rational/clearcase';
}
$CLEARCASE_LIGHT = "";
$MDEP_VAR_DIR               =  '/var';
$MDEP_VAR_ATRIA_DIR         =  $MDEP_VAR_DIR.'/adm/rational/clearcase';
$MDEP_TMPDIR                =  '/usr/tmp';
$MDEP_ATRIA_DIR             =  $atria_home;
$MDEP_ATRIA_BIN_DIR         = $MDEP_ATRIA_DIR.'/bin';
$MDEP_ATRIA_ETC_DIR         = $MDEP_ATRIA_DIR.'/etc';
$MDEP_CLEARTOOL             = $MDEP_ATRIA_BIN_DIR.'/cleartool';
$MDEP_ATRIA_LOG_DIR         = $MDEP_VAR_ATRIA_DIR.'/log';
$MDEP_ATRIA_CONF_DIR        = $MDEP_VAR_ATRIA_DIR.'/config';
$MDEP_STOP_CCASE            = $MDEP_ATRIA_ETC_DIR.'/atria_start stop';
$MDEP_START_CCASE           = $MDEP_ATRIA_ETC_DIR.'/atria_start start';
$MDEP_DBCHECK               = $MDEP_ATRIA_ETC_DIR.'/utils/dbcheck -a';
$MDEP_VOB_SERVER_CONF       = 'vob_server.conf';
$MDEP_VOB_SETUP             = $MDEP_ATRIA_ETC_DIR.'/vob_snapshot_setup';

#
# Some needed commands
#
$MDEP_RMDIR_COMMAND         =  '/bin/rm -rf';
$MDEP_RMFILE_COMMAND        =  '/bin/rm -f';
$MDEP_HOSTNAME_PROGRAM      =  'uname -n';
$MDEP_MOVE                  =  '/bin/mv';
$MDEP_SHELL                 =  '/bin/sh';
$VOB_SNAPSHOT_DEVNULL       =  '/dev/null';
$MDEP_TIME_STAMP            =  '/bin/date +"%D %T"';
#MDEP_TIME_STAMP_NOSLASH    =  '/bin/date +"%d.%m.%y-%H:%M:%S";
$MDEP_GET_LOGIN             =  '/bin/id';
$MDEP_ECHO                  =  'echo';
$MDEP_CCASE_RUNNING         =  '/bin/ps -ef';
$MDEP_COMMAND_FAILURE       = 'Command Failure';

#
# Some defaults
#
$MDEP_D_NOTIFY_PROGRAM      = $MDEP_ATRIA_BIN_DIR.'/notify';
$MDEP_D_NOTIFY_LIST         = 'root';
$MDEP_D_CONFIRM_SUCCESS     = 'yes';


#
# Some convenience definitions.
#
$MDEP_DESCRIBE              = "$MDEP_CLEARTOOL describe";
$MDEP_LSVOB                 = "$MDEP_CLEARTOOL lsvob";
$MDEP_GET_SNAP_ATTR         = 
    "$MDEP_DESCRIBE -aattr %s replica:%s@%s";
$MDEP_CHECKVOB             = "$MDEP_CLEARTOOL checkvob";
$MDEP_CHECKVOB_FIX_COMMAND  =    
    "$MDEP_CHECKVOB -fix %s -log %s -pool %s";
$MDEP_REPLACE_LOCK          = '-replace';
$MDEP_NO_REPLACE_LOCK       = "No Replace Lock";
$MDEP_DEFFERED_DEL_PARAMETER = 'DeferredSourceContainerDeletion';


#
# The one exception to the naming rule in this module. This is 
# the name of the snapshot parameter attribute that gets attached
# replicas that need to be snapped. The parameter, recover and snapshot
# scripts must see the same name so its here. Its description is 
# in vob_snapshot.pl. 
#
$SNAP_REP_PARAMETERS        =  "vob_snapshot_parameters";

#
# The string used to parse the parameters. The describe gets the attribute
# by name and formats it as "%Na".
# 
$SNAP_REP_PARAMETERS_PARSE  = 
     '    vob_snapshot_parameters = "dbcheck=(.*);snap_to=(.*);notify=(.*)"$';



$MDEP_SEP                           = '/';

@MDEP_DB_EXCLUDES                   = ("^\\.\$",
                                       "^\\.\\.\$",
                                       "^vista\\.taf\$",
                                       "^db_dumper\$");

@MDEP_MUST_HAVE                     = ('db/vob_db.dbd',
                                       'db/vob_db.d01',
                                       'db/vob_db.d02',
                                       'db/vob_db.d03',
                                       'db/vob_db.k01',
                                       'db/vob_db.k02',
                                       'db/vob_db.k03',
                                       'db/vob_db.k04',
                                       'db/vob_db.str_file',
                                       'db/vob_db_schema_version',
                                       'db/logs');


$MDEP_YES_OR_NO                    = "yes,no";
$MDEP_YES_OR_NO_HELP               = "yes,no,help";
$MDEP_YES_NO_OR_QUIT               = "yes,no,quit";
$MDEP_YES_NO_QUIT_HELP             = "yes,no,quit,help";
$MDEP_YES_QUIT                     = "yes,quit";
$MDEP_YES                          = "yes";
$MDEP_QUIT                         = "quit";
$MDEP_YES_HELP                     = "yes,help";
$MDEP_YES_HELP_QUIT                = "yes,quit,help";
$MDEP_NO                           = "no";
$MDEP_NO_HELP                      = "no,help";
$MDEP_QUIT_RESPONSE                = "quit";
$MDEP_QUIT_HELP                    = "quit,help";
$MDEP_NL_RESPONSE                  = "";
$MDEP_HELP_RESPONSE                = "help";
$MDEP_RETURN_TO_CONTINUE           = "<RETURN> to continue";
$MDEP_QUIT_RETURN_TO_CONTINUE      = "quit,<RETURN> to continue";
$MDEP_ANY_RESPONSE                 = "any response allowed";
$MDEP_NO_HELP                      = "";
$MDEP_NO_DEFAULT                   = "";
$MDEP_FATAL = "FATAL";
$MDEP_ERROR = "ERROR";

$RTN_FILE_NULL                     = "File Name Is Null";
$RTN_FILE_NOT_EXIST                = "File Does Not Exist";
$RTN_FILE_OPEN_FAILED              = "File Open Failed";
$RTN_FILE_OPEN_OK                  = "File Open Ok";
$RTN_FILE_UNWRITABLE               = "File Not Writable";
$RTN_FILE_UNREADABLE               = "File Not Readable";
$RTN_FILE_NO_EXECUTE               = "File No Execute";
$RTN_FILE_IS_DIRECTORY             = "File Is Directory";
$RTN_DIR_NULL                      = "Directory Name Is Null";
$RTN_DIR_NOT_EXIST                 = "Directory Does Not Exist";
$RTN_DIR_OPEN_FAILED               = "Directory Open Failed";
$RTN_DIR_OPEN_OK                   = "Directory Open Ok";
$RTN_DIR_UNWRITABLE                = "Directory Not Writable";
$RTN_DIR_UNREADABLE                = "Directory Not Readable";
$RTN_DIR_NO_EXECUTE                = "Directory No Execute";
$RTN_DIR_NOT_DIRECTORY             = "Directory Not a Directory";
$RTN_DIR_IS_FILE                   = "Directory Is File";
$RTN_PDIR_NULL                     = "Parent Directory Is Null";
$RTN_PDIR_NOT_EXIST                = "Parent Directory does Not Exist";
$RTN_PDIR_OPEN_FAIED               = "Parent Directory Open Failed";
$RTN_PDIR_OPEN_OK                  = "Parent Directory Open Ok";
$RTN_PDIR_UNWRITABLE               = "Parent Directory Not Writable";
$RTN_PDIR_UNREADABLE               = "Parent Directory Not Readable";
$RTN_PDIR_NO_EXECUTE               = "Parent Directory No Execute";
$RTN_PDIR_NOT_DIRECTORY            = "Parent Directory Not a Directory";
$RTN_PATH_NULL                     = "Path Name Is Null";
$RTN_PATH_NOT_EXIST                = "Path Does Not Exist";
$RTN_PATH_OPEN_FAILED              = "Path Open Failed";
$RTN_PATH_OPEN_OK                  = "Path Open Ok";
$RTN_PATH_UNWRITABLE               = "Path Not Writable";
$RTN_PATH_UNREADABLE               = "Path Not Readable";
$RTN_PATH_NO_EXECUTE               = "Path No Execute";

$RTN_BAD_MODE                      = "Bad Mode";
$RTN_BAD_PATH                      = "Bad Path";
$RTN_GOOD_PATH                     = "Good Path";

$RTN_COPY_FAILED                   = "Copy Failed";
$RTN_COPY_OK                       = "Copy Ok";

$RTN_RENAME_FAILED                 = "Rename Failed";
$RTN_RENAME_OK                     = "Rename Ok";

$RTN_LOCK_FAILED                   = "Lock Operation Failed";
$RTN_LOCK_OK                       = "Lock Operation Ok";
$RTN_LOCK_WAS_LOCKED               = "Lock Was Locked";
$RTN_UNLOCK_FAILED                 = "Unlock Operation Failed";
$RTN_UNLOCK_OK                     = "Unlock Operation Ok";
$RTN_LOCK_WAS_UNLOCKED             = "Unlock Was Unlocked";

$RTN_REGISTER_FAILED               = "Register Failed";
$RTN_REGICTER_OK                   = "Register Ok";
$RTN_UNREGISTER_FAILED             = "Unregister Failed";
$RTN_NOT_REGISTERED                = "Not Registered";
$RTN_UNREGICTER_OK                 = "Unregister Ok";

$RTN_REPLICA_UUID_NULL             = "Replica Uuid Null";
$RTN_FAMILY_UUID_NULL              = "Family Uuid Null";

$RTN_VOB_TAG__NULL                 = "Vob Tag Is Null";
$RTN_RMTAG_OK                      = "Rmtag Operation Ok";
$RTN_NO_TAG                        = "No Tag";
$RTN_MKTAG_FAILED                  = "Mktag Operation Failed";

$RTN_VOB_INFO_INCONSISTENT         = "Vob Info Inconsistent";

$RTN_CCASE_START_FAILED            = "Clearcase Start Failed";
$RTN_CCASE_START_OK                = "Clearcase Start Ok";
$RTN_CCASE_STOPFAILED              = "Clearcase Stop Failed";
$RTN_CCASE_STOP_OK                 = "Clearcase Stop Ok";

$RTN_MOUNT_FAILED                  = "Mount Failed";
$RTN_MOUNT_OK                      = "Mount Ok";
$RTN_UMOUNT_FAILED                 = "Umount Failed";
$RTN_UMOUNT_OK                     = "Umount Ok";

$RTN_INVALID_TAG                   = "Invalid Tag";
$RTN_VALID_TAG                     = "Valid Tag";

$RTN_DB_PROTECTED                  = "Db Protected";
$RTN_DB_UNPROTECTED                = "Db Unprotected";

$RTN_DBCHECK_FAILED                = "Dbcheck Failed";
$RTN_DBCHECK_OK                    = "Dbcheck Ok";

$RTN_BAD_PARAMETERS                = "Bad Parameters";

$RTN_NOT_OK                        = "All Not Ok";
$RTN_OK                            = "All Ok";
$RTN_SET                           = "Is set";
$RTN_NOT_SET                       = "Is Not Set";
$RTN_NO_STATUS_SET                 = "No Return Status Set";

$RTN_EQUAL                         = "Are Equal";
$RTN_NOT_EQUAL                     = "Are Not Equal";

$RTN_FALSE                         = 0;
$RTN_TRUE                          = 1;

$RTN_QUIT                          = "Quit";

$MDEP_ERROR_STR                    = "ERROR   ";
$MDEP_FATAL_STR                    = "FATAL   ";
$MDEP_WARN_STR                     = "WARNING ";
$MDEP_NOTE_STR                     = "NOTE    ";
$MDEP_UNKNOWN_STR                  = "Unknown Error Type";

#
# Error handling constants
# Used to construct the error routing tokens below. 
#
$MDEP_ERROR                   = 0x0010;      # Non fatal error
$MDEP_FATAL                   = 0x0020;      # Fatal error
$MDEP_WARN                    = 0x0040;      # Just a warning
$MDEP_NOTE                    = 0x0080;      # Only a note
$MDEP_NOTIFY                  = 0x0001;      # Send notification only
$MDEP_LOG                     = 0x0002;      # Write out the log only
$MDEP_BOTH                    = 0x0003;      # Mail it and log it

#
# What kind of message is being logged. One is passed as a first
# argument to &mdep_logger. 
#
$MDEP_E_N                     = $MDEP_ERROR | $MDEP_NOTIFY;
$MDEP_E_L                     = $MDEP_ERROR | $MDEP_LOG;   
$MDEP_E_B                     = $MDEP_ERROR | $MDEP_BOTH;
$MDEP_F_N                     = $MDEP_FATAL | $MDEP_NOTIFY;
$MDEP_F_L                     = $MDEP_FATAL | $MDEP_LOG;
$MDEP_F_B                     = $MDEP_FATAL | $MDEP_BOTH;
$MDEP_W_N                     = $MDEP_WARN  | $MDEP_NOTIFY;
$MDEP_W_L                     = $MDEP_WARN  | $MDEP_LOG;
$MDEP_W_B                     = $MDEP_WARN  | $MDEP_BOTH;
$MDEP_N_N                     = $MDEP_NOTE  | $MDEP_NOTIFY;
$MDEP_N_L                     = $MDEP_NOTE  | $MDEP_LOG;
$MDEP_N_B                     = $MDEP_NOTE  | $MDEP_BOTH;

sub system_redirect {
    
    local($command) = @_[0];
    local($ret_status);
    local($tmpname);
    
    $tmpname = &mdep_get_tmpname();
    $ret_status = system("$command > $tmpname 2>&1");
    
    #
    # Don't call mdep_rmfile - it calls system_redirect. 
    #
    system("$MDEP_ECHO | $MDEP_RMFILE_COMMAND $tmpname");
    return $ret_status;
    
}

#
# mdep_internal_error_str()
# Inputs:
#   $module
#     The name of the calling program.
#   $identifier
#     The error identifier. Should be of the form "###". If a new internal 
#     error is found add another number to the list contained in the
#     the calling module. The ones in use should be listed in the callers
#     module and should be of the form MODULE_INTERNAL_ERROR_###. As an
#     example, the vob recover script contains....
#        $RECOVER_INTERNAL_ERROR_001 = "001;
#        $RECOVER_INTERNAL_ERROR_002 = "002;
#        $RECOVER_INTERNAL_ERROR_003 = "003;
#        $RECOVER_INTERNAL_ERROR_004 = "004;
#                         .
#                         .
#                         .
#     The idea is to be able to grep the module for the the appropriate
#     MODULE_INTERNAL_ERROR_### sting given a '###' from support. 
#   $release
#     The format preceeds the the identifier with this field. In case
#     the meaning of the $identifier changes from one release to another
#     this will maintain uniquness. As an example, the vob_recover script
#     cotained the definition
#        $RECOVER_RELEASE = "R3.0B1";
#     for the first beta release of 3.0 and similary will contain.
#        $RECOVER_RELEASE = "R3.0";
#     for the 3.0 release. The definition is arbitrary but different
#     for different releases of the calling module.
#   $error
#     The error string. 
# Outputs:
#   None
# Returns:
#   None
# References:
#   None
# Modifies:
#   None
# Calls:
#   &mdep_error()
# Description:
#   The idea is to uniquely identify internal errors across various 
#   translations of the error strings themselves. The definitions of
#   $identifier and $release desribed above should probably be preceeded
#   by a not to the translator to not translate them. In this way support
#   can always ask for the identifier and a grep of the appropriate release
#   for the module can be done. None internal errors messages shouldn't
#   require a call to support to resolve. 
sub mdep_internal_error_str {

    local($identifier) = @_[0];     # The error identifier
    local($release) = @_[1];        # The release string
    local($error) = @_[2];          # The error string
    local($fstr) = "";              # Format string buffer

    $MDEP_INTERNAL_CONSISTENCY_STR  = 
"An internal consistency failure [%s.%s] has occurred
Contact your support representative with the information contained in this 
message.
%s\n";

    $fstr = sprintf($MDEP_INTERNAL_CONSISTENCY_STR,$release,
		    $identifier,$error);
    
    return $fstr;

}


#
# mdep_prompt()
# Inputs: 
#   $arg_prompt
#     The prompt string to emit.
#   $arg_options
#     The accepted responses - a single string containing comma seperated
#     list. 
#   $arg_default
#     The default. It must be either null or one of the responses in 
#     $options.
#   $arghelp
#     Help string if available, null if not.
# Outputs:
#   None
# Returns
#   One of the accepted responses.
# References:
#   None
# Modifies:
#   None
# Calls:
#   &mdep_error()
# Description:
#   A formatted prompt is sent to the user and a response is read. The 
#   optional responses and default, if there is one, are formatted 
#   with the $prompt argument. The formatted prompt informs the user 
#   whether or not there is a default. If the response obtained is not 
#   a valid one, another is requested. There is no default if $default 
#   is null. In this case resposes are requested until a valid one is 
#   gotten. The special $options string $MDEP_ANY_RESPONSE indicates 
#   that any response is allowed. Just return the string the user types. 
#   If $help is set one of the allowed responses should be 
#   $MDEP_HELP_RESPONSE. If this response is seen the help string is 
#   put out, a wait is done for any key from the user, and the $prompt 
#   is sent again. If help is intended for the $MDEP_ANY_RESPONSE, 
#   case the help option should be included in the prompt string itself,
#   and $help should contain a help string. Use $MDEP_HELP_RESPONSE for 
#   string to specify its availability. 
#
sub mdep_prompt {

    local($arg_prompt) = @_[0];    # The prompt sring
    local($arg_options) = @_[1];   # The optional responses
    local($arg_default) = @_[2];   # The default
    local($arg_help) = @_[3];      # The help string
    local(@options);               # The options in reasonable form
    local($option);                # Single option holder.
    local($fstr) = "";             # The format string
    local($reply) = "";            # Local reply holder
    local($is_default) = 0;        # Set if there is a default
    local($help_available) = 0;    # Set if help is available
    local($any_allowed) = 0;       # Set if any response is allowed

    $MDEP_P_FORMAT_WITH_DEFAULT =
"%s
Valid responses are (%s) 
The default is %s: ";

    $MDEP_P_FORMAT_WITHOUT_DEFAULT =
"%s
Valid responses are (%s) 
There is no default response: ";

    $MDEP_FORMAT_ANY_RESPONSE_ALLOWED = "%s";
    #
    # Check for anything allowed. Its a simple string token so
    # no need to do the split if its set.
    #
    if($arg_options eq $MDEP_ANY_RESPONSE) {

	$any_allowed = 1;
	#
	# Any can't specify help so rely on the help string itself to
        # indicate its availability.
	#
	if($arg_help ne "") {

	    $help_available = 1;

	}
    }
    else {

	#
	# Put the options in a reasonable form.
	#
	@options = split(',',$arg_options);
	# 
	# See if help is available
	#
	foreach $option (@options) {

	    if($option eq $MDEP_HELP_RESPONSE) {

		if($arg_help ne "") {

		    $help_available = 1;
		    last;
		}
	    }
	}
    }

    #
    # Format the prompt string.
    #
    if($arg_options eq $MDEP_ANY_RESPONSE) {

	$fstr = $arg_prompt;
    }
    elsif($arg_default ne "") {

	# 
        # A default was given. Set $answer to the default and do format
        # to give default to the user.
        #
	$fstr = sprintf($MDEP_P_FORMAT_WITH_DEFAULT,
			$arg_prompt,$arg_options,$arg_default);
    }
    else {

        #
        # No default was given. Format to tell user there is no default
        # response.
        #
	$fstr = sprintf($MDEP_P_FORMAT_WITHOUT_DEFAULT,
			$arg_prompt,$arg_options);
    }

    if($arg_default) {

	$is_default = 1;
    }

ASK_AGAIN:
    while (1) {

	print "\n$fstr";
	$reply = <STDIN>;
        chop $reply;

	#
	# Check for the help string up front if its available
	#
	if($reply eq $MDEP_HELP_RESPONSE) {
	    if($help_available) {

		print "\n$arg_help";
		print "\nPress <RETURN> to return to the prompt.....";
		#
		# Wait for any key. This response gets dropped.
		#
		$reply = <STDIN>;
		next ASK_AGAIN;
	    }
	    else {
		print 
"\nNo help is available for this prompt. 
Press <RETURN> to continue.....\n";
		$reply = <STDIN>;
		next ASK_AGAIN;
	    }
	}
	
	#
        # If the user just hit return and there is a default return the
        # default answer.
        #
	if($reply eq $MDEP_NL_RESPONSE) {

	    if($is_default) {

		return $arg_default;
	    }
	    else {

		if($any_allowed) {

		    return $reply;
		}

		foreach $option (@options) {

		    if($option eq $MDEP_RETURN_TO_CONTINUE) {
			return $reply;
		    }
		}
		
		next ASK_AGAIN;
	    }
	}

	#
	# If anything else is allowed return it.
	#
	if($any_allowed) {

	    return $reply;
	}

	#
	# See if its another valid response
	#
	foreach $option (@options) {
            
	    if($reply eq $option) {

		return $reply;
	    }
	}
    }
}




sub mdep_error {

    local($program_name) = @_[0];
    local($function) = @_[1];
    local($level) = @_[2];
    local($message) = @_[3];
    print "\n\nError: $program_name encountered an error in $function:\n$message";
    if( $level eq "FATAL" ) {exit();}
    
}


sub mdep_get_tmpname {
    
    $vob_recover_tmpseq++;
    
    return "${MDEP_TMPDIR}/vob_snapshot_tmp.$$.${vob_recover_tmpseq}";
    
}

sub mdep_command {
    local($command) = @_[0];
    local($tmpname);
    local($status);
    local(@cmdbuf);
    local($line);
    local(@args);
 
    $command = @_[0];
    if($command eq "") {
        @cmdbuf[0] = $MDEP_COMMAND_FAILURE;
        return @cmdbuf;
    }
 
    @args = split(' ',$command);
    if(! -x @args[0]) {
        @cmdbuf[0] = $MDEP_COMMAND_FAILURE;
        return @cmdbuf;
    }
 
    $tmpname = &mdep_get_tmpname();
    $status = system("$command > $tmpname 2>&1");
 
    if($status != 0) {
        &mdep_rmfile($tmpname);
        @cmdbuf[0] = "Command Failure";
        return @cmdbuf;
    }
 
    #
    # Read lines of output untill there are no more. Push each line
    # onto the return array.
 
    open(NODROP_COMMAND_BUF,$tmpname);
    foreach $line (<NODROP_COMMAND_BUF>) {
        push(@cmdbuf,$line);
    }
    close(NODROP_COMMAND_BUF);
    &mdep_rmfile($tmpname);
    return @cmdbuf;
 
}

sub mdep_command_s {
    
    local(*command,*cmdbuf) = @_;
    local($tmpname);
    local($status);
    local($line);
    local(@args);
    
    if($command eq "") {
	return 1;
    }
    @args = split(' ',$command);
    if(! -x @args[0]) {

	return 1;
    }
    
    $tmpname = &mdep_get_tmpname();
    $status = system("$command > $tmpname 2>&1");
    
    #
    # Read lines of output untill there are no more. Push each line
    # onto the return array.

    open(NODROP_COMMAND_BUF,$tmpname);
    foreach $line (<NODROP_COMMAND_BUF>) {
	push(@cmdbuf,$line);
    }
    close(NODROP_COMMAND_BUF);
    &mdep_rmfile($tmpname);
    return $status;

} 

sub mdep_get_time {
    
    local($status);
    local($tmpname);
    local($date);
    local($command);
    
    $command = $MDEP_TIME_STAMP;
    $tmpname = &mdep_get_tmpname();  
    $status = system("$command > $tmpname 2>&1");
    if($status != 0) {
	$date = "";
    } 
    else {
	open(DATE_FILE,$tmpname);    
	if(read(DATE_FILE,$date,80) == 0) {
	    $date = "";
	}
    }
    close(DATE_FILE);
    &mdep_rmfile($tmpname);
    chop $date;
    return $date;
    
    
}


sub mdep_dirname {
    
    local($path) = @_[0];      # Path
    local($lslash);            # Index to the last slash in $path
    
    
    #
    # Check for a null input first.
    if($path eq "") {

	return $RTN_PATH_NULL;

    }

    $lslash = rindex($path,'/');
    if($lslash == -1) {

	# 
	# No slashes. Must be in the current working directory.
	#
	return '.';

    }
    else {

	#
	# Pick it out
	#
	return substr($path,0,$lslash);

   }

}


sub mdep_basename {

    local($path) = @_[0];      # Path
    local($lslash);            # Index to the last slash in $path


    #
    # Check for a null input first.
    if($path eq "") {

	return $RTN_PATH_NULL;

    }

    $lslash = rindex($path,'/');
    if($lslash == -1) {

	# 
	# No slashes. Must be in the current working directory.
	#
	return $path;

    }
    else {

	#
	# Pick it out
	#
	return substr($path,$lslash+1);

   }
}
    



sub mdep_get_hostname {

    local($hostname) = "";
    
    $hostname = `$MDEP_HOSTNAME_PROGRAM`;
    chop $hostname;
    return($hostname);

}



sub mdep_dodbcheck {

    local($storage) = @_[0];
    local($dbdir);
    local($dbname);
    local($tmpname);

    
    $dbdir = $storage.$MDEP_SEP.'db';
    $dbname = $dbdir.$MDEP_SEP.'vob_db';

    if(system("$MDEP_DBCHECK $dbname > /dev/null 2>&1")) {

	return  $RTN_DBCHECK_FAILED;
    }
    
    return $RTN_DBCHECK_OK;

}


sub mdep_is_clearcase_up {

    local(@cmdbuf); 
    local($command);
    local($status);

    $command = $MDEP_CCASE_RUNNING;
    $status = &mdep_command_s(*command,*cmdbuf);
    if($status) {

	return -1;
    }
    if(grep(/albd/,@cmdbuf)) {

	return 1;
    }
    else {

	return 0;
    }
}
	   
	   

	
sub mdep_stop_clearcase {

    local($status);        # Return status
    local($tmpname);
    local($line);

    $tmpname = &mdep_get_tmpname();
    $status = system("$MDEP_STOP_CCASE > $tmpname 2>&1");

    if($status) {

	#
	# If the failure was a umount problem ignore it.
	#
	unless(open(TMPFILE,$tmpfile)) {
            &mdep_rmfile($tmpname);
	    return $RTN_CCASE_STOP_FAILED;
	}

	foreach $line (<TMPFILE>) {

	    if($line =~ /Refer to the log.*mntrpc_server_log/) {
		&mdep_rmfile($tmpname);
		return $RTN_CCASE_STOP_OK;
	    }
	}
	close(TMPFILE);
	&mdep_rmfile($tmpname);
	return $RTN_CCASE_STOP_FAILED;
    }
    &mdep_rmfile($tmpname);
    return $RTN_CCASE_STOP_OK;
}  



sub mdep_start_clearcase {

    local($status);        # Return status
    local($tmpname);
    local($line);
    local($ret_status);

CLEANUP_START_CLEARCASE: {

    $tmpname = &mdep_get_tmpname();
    $status = system("$MDEP_START_CCASE > $tmpname 2>&1");

    if($status) {

	#
	# If the failure was a umount problem ignore it.
	#
	unless(open(TMPFILE,$tmpname)) {

	    $ret_status = $RTN_CCASE_START_FAILED;
	}

	foreach $line (<TMPFILE>) {

	    if($line =~ /Refer to the log.*mntrpc_server_log/) {
                
		$ret_status =  $RTN_CCASE_START_OK;
                last CLEANUP_START_CLEARCASE;
	    }
	}

	$ret_status =  $RTN_CCASE_START_FAILED;
    }

    $ret_status = $RTN_CCASE_START_OK;

} CLEANUP_START_CLEARCASE:

    close(TMPFILE);
    &mdep_rmfile($tmpname);
    return $ret_status;
}  



sub mdep_mk_attribute_string {

    local($dbcheck) = @_[0];
    local($snap_to) = @_[1];
    local($notify) = @_[2];
    local($attr_cvt);
    local($attr);
    $attr = "dbcheck=${dbcheck};snap_to=${snap_to};notify=${notify}";
    ($attr_cvt = $attr) =~ s/\;/\\\;/g;
    return($attr_cvt);
}



sub mdep_rmfile {

    local($path) = @_[0];
    
    if($path eq "") {
	return $RTN_PATH_NULL;
    }
    if(system("$MDEP_RMFILE_COMMAND $path")) {
	
	return $RTN_NOT_OK;
    }
    
    return $RTN_OK;
}

sub mdep_get_local_tags_clt {

    local(*host,*tags) = @_;
    local($line);
    local($tag);
    my($h);
    local(@lcmdbuf);
    #
    # Save NLSPATH and set to null for English
    #
    $NLSPATH = $ENV{NLSPATH}; 
    $ENV{NLSPATH} = "";
    @lcmdbuf = &mdep_command("$MDEP_CLEARTOOL lsvob -long");
    #
    # Now restore NLSPATH 
    #
    $ENV{NLSPATH} = $NLSPATH; # Reset NLSPATH
    if(@lcmdbuf[0] eq $MDEP_COMMAND_FAILURE) {
        return $RTN_NOT_OK;
    }
    foreach (@lcmdbuf) {
	if(/^Tag:\s+(\\.*)$/ || /Tag:\s+(\/.*)$/) {
	    $tag = $1;
	    $tag =~ s/(.*)\s+"(.*?)"$/$1/;
	} elsif(/^Vob on host: (.*)$/) {
	    $h = $1;
	    if(lc($h) eq lc($host)) {
		$tag .= "\n";
		push(@tags,$tag);
    }
	}
    }
    return $RTN_OK;

}


sub mdep_get_local_tags {

    local(*host,*tags) = @_;
    local($line);
    if ($CLEARCASE_LIGHT) {
        return mdep_get_local_tags_clt(@_);
    } 
    #
    # Save NLSPATH and set to null for English
    #
    $NLSPATH = $ENV{NLSPATH}; 
    $ENV{NLSPATH} = "";
    @tags = &mdep_command("$MDEP_CLEARTOOL lsvob -short -host $host");
    #
    # Now restore NLSPATH 
    #
    $ENV{NLSPATH} = $NLSPATH; # Reset NLSPATH

    if(@tags[0] eq $MDEP_COMMAND_FAILURE) {
	
        return $RTN_NOT_OK;	
    }
    return $RTN_OK;
}



sub mdep_rmdir {
    
    local($dirpath) = @_[0];
    local($status);   
    
    if($dirpath eq "") {
	print "null directory\n";
	return(-1);
    }
    
    if(! -d $dirpath) {
	print "directory $dirpath does not exist\n";
	return(-1);
    }
    $status = system("$MDEP_RMDIR_COMMAND $dirpath");
    
    return($status);
    
}

sub mdep_skip_directory {

    local($dir) = @_[0];     # The directory to check.

    if(($dir eq '.') ||
       ($dir eq '..')) {
	
	return $RTN_TRUE;

    }

    return $RTN_FALSE;
}
			   


sub mdep_unregister_vob_object {

    local($replica_uuid) = @_[0];       # Vob replica uuid
    local($status);                     # Return status
    local(@cmdbuf);                     # Return buffer for mdep_command
    local($line);                       # Line buffer for parsing
    local($ret_status);                 # Return status
  
CLEANUP_UNREGISTER_VOB_OBJECT: { # Always return at end of this block.

    if($replica_uuid eq "") {

	$ret_status = $RTN_REPLICA_UUID_NULL;
	last CLEANUP_UNREGISTER_VOB_OBJECT;
    }

    @cmdbuf = &mdep_command(
		    "$MDEP_CLEARTOOL unregister -vob -uuid $replica_uuid");

    if(@cmdbuf eq $MDEP_COMMAND_FAILURE) {
	
	#
	# See if it failed because it was already unregistered.
	#
	foreach $line (@cmdbuf) {

	    if($line =~ /Unable to find a registry entry for VOB/) {

		$ret_status = $RTN_NOT_REGISTERED;
		last CLEANUP_UNREGISTER_VOB_OBJECT;
	    }
	}

	$ret_status =  $RTN_UNREGISTER_FAILED;
	last CLEANUP_UNREGISTER_VOB_OBJECT;
    }

    $ret_status =  $RTN_UNREGISTER_OK;

  } # CLEANUP_UNREGISTER_VOB_OBJECT Always return here

    return $ret_status;
}




sub mdep_register_vob_object {

    local($storage) = @_[0];       # Vob storage area
    local($status);                # Return status
  
    if($storage eq "") {

	return $RTN_PATH_NULL;

    }
    $status = system_redirect("$MDEP_CLEARTOOL register -vob $storage");
    if($status) {

	return $RTN_REGISTER_FAILED;

    }
    return $RTN_REGISTER_OK;
    
}

sub mdep_rmtag {

    local($vobtag) = @_[0];       # Vob tag
    local($status);               # Return status
    local(@cmdbuf);               # Return buffer for mdep_command
    local($line);                 # Line buffer for parsing
    local($ret_status);           # Return status

  
CLEANUP_RMTAG: { # Always return at end of this block.

    if($vobtag eq "") {

	$ret_status = $RTN_VOB_TAG_NULL;
	last CLEANUP_RMTAG;
    }

    @cmdbuf = &mdep_command("$MDEP_CLEARTOOL rmtag -vob $vobtag");
    
    if(@cmdbuf eq $MDEP_COMMAND_FAILURE) {

	#
	# See if it failed because the tag doesn;t exist
	#
	foreach $line (@cmdbuf) {

	    if($line =~ /is not a registered vob tag/) {

		$ret_status = $RTN_NO_TAG;
		last CLEANUP_RMTAG;
	    }
	}


	$ret_status =  $RTN_RMTAG_FAILED;
	last CLEANUP_RMTAG;

    }

    $ret_status = $RTN_RMTAG_OK;

  } # CLEANUP_RMTAG Always return here

    return $ret_status;
}

sub mdep_mktag {

    local($vobtag) = @_[0];       # Vob tag
    local($spath) = @_[1];        # Vob storage path
    local($status);               # Return status
  
    if($vobtag eq "") {

	return $RTN_VOB_TAG_NULL;

    }

    if($spath eq "") {

	return $RTN_PATH_NULL;

    }


    $status = system("$MDEP_CLEARTOOL mktag  -vob -tag $vobtag $spath");
    if($status) {

	return $RTN_MKTAG_FAILED;

    }

    return $RTN_MKTAG_OK;
}


# 
# mdep_copy_file 
# Inputs:
#   $source 
#     The path of the source file
#   $target
#     THe target file path or a target directory to get $source.
# Outouts:
#   None
# Returns:
#   None
# References:
#   None
# Modifies:
#   None
# Calls:
#   None
# Description:
#   If $target is a file name copy $source to $target. If $target is a 
#   directory copy $source into $target.
#
sub mdep_copy_file {

    local($spath) = @_[0];        # Source path
    local($tpath) = @_[1];        # Destination path
    local($ddir);                 # Destination directory
    local($dfile);                # Destination basename
    local($sdir);                 # Source directory 
    local($sfile);                # Source basename
    local($ren_src);              # Rename source if we have to rename
    local($ren_dest);             # Rename destination if we have to rename

    #
    # Check for null paths
    #
    if($spath eq "") {

	return $RTN_PATH_NULL;

    }
    if($tpath eq "") {

	return $RTN_PATH_NULL;

    }

    #
    # If the source is a directory the wrong function was called.
    # This one only does regular files.
    #
    if(-d $spath) {

	return $RTN_FILE_IS_DIRECTORY;

    }

    #
    # See if $target is a directory or regular file.
    #
    if(-d $tpath) {

	# 
	# In this case the destination directory realy is $target. Set
	# the destination basename to null.
        #
	$ddir = $tpath;
	$dfile = "";
    }
    else {

	#
	# $target is the pathname for a regular file. THe target 
        # directory will be the directory to contain this regular file 
	# $dfile gets the regular file name. $dfile may or may not be 
	# the same as $sfile.
	#
	$ddir = &mdep_dirname($tpath);
	if($ddir eq $RTN_PATH_NULL) {

	    return $RTN_PATH_NULL;

	}
	$dfile = &mdep_basename($tpath);
	if($dfile eq $RTN_PATH_NULL) {

	    return $RTN_PATH_NULL;

	}


    }

    #	
    # Get the directory and basename for the source.
    # 
    $sdir = &mdep_dirname($spath);
    if($sdir eq $RTN_PATH_NULL) {

	return $RTN_PATH_NULL;

    }
    $sfile = &mdep_basename($spath); 
    if($sfile eq $RTN_PATH_NULL) {
	
	return $RTN_PATH_NULL;
	

    }
    
    #
    # Check for read and write on the source directory. Just write on the
    # target. 
    #
    if(! -r $sdir) {

	return $RTN_DIR_UNREADABLE;

    }

    #
    # Check to see if the destination directory exists
    #
    if(! -d $ddir) {

	return $RTN_DIR_NOT_EXIST;

    }
    if(! -w $ddir) {

	return $RTN_DIR_UNWRITABLE;

    }

    #
    # See if the source exists
    #
    if(! -e $spath) {

	return $RTN_FILE_NOT_EXIST;

    }

    #
    # Now check read on source file.
    # 
    if(! -r $spath) {

	return $RTN_FILE_UNREADABLE;

    }

    #
    # Ok. So see if the copy works. mdep_copy_file uses tar so 
    # send it everything it needs.
    #
    if(system("(cd $sdir; find $sfile -print | cpio -pdmu $ddir > /dev/null 2>&1)")) {
    

	return $RTN_COPY_FAILED;

    }
    else {

	#
	# If the copy was to a regular file whose name differs from the
        # source rename it now. $dfile is set only if the target is a 
	# regular file so we need only do the compare since we know $sfile
        # is never empty. 
	#
        if(($dfile ne "") &&
	   ($sfile ne $dfile)) {

	    $ren_src = $ddir.$MDEP_SEP.$sfile;
	    $ren_dest = $ddir.$MDEP_SEP.$dfile;
	    rename($ren_src,$ren_dest);
	}

	return $RTN_COPY_OK;

    }
    
}


#
# mdep_copy_directory
# Inputs: 
#   spath
#     The source path to copy.
#   tpath
#     The target path to contain the copy.
# Ouputs:
#   None
# Returns
#   None
# References:
# Modifies:
# Calls:
# Description:
#   Recursivly copy $source into the $target directory.
sub mdep_copy_directory {

    local($spath) = @_[0];     # Source directory path
    local($tpath) = @_[1];     # Target directory path
    local($pdir);              # Parent of the source directory
    local($sname);             # Name of the source directory - not path.
    


    #
    # Check the arguments.
    #
    if($spath eq "") {

	return $RTN_PATH_NULL;

    }
    if($tpath eq "") {

	return $RTN_PATH_NULL;
    
    }
    
    #
    # Make sure they are both directories
    # 
    if(! -d $spath) {

	return $RTN_DIRECTORY_NOT_DIRECTORY;
    }
    if(! -d $tpath) {

	return $RTN_DIRECTORY_NOT_DIRECTORY;

    }

    #
    # Check permissions
    #
    if(! -r $spath) {

	return $RTN_DIR_UNREADABLE;

    }

    if(! -w $tpath) {

	return $RTN_DIR_UNWRITABLE;

    }

    #
    # Get the path of thee directory containing the source. We use tar
    # so we have to cd to this directory.
    #
    $pdir = &mdep_dirname($spath);
    if($pdir eq $RTN_PATH_NULL) {

	return $RTN_PATH_NULL;

    }
    $sname = &mdep_basename($spath);
    if($sname eq $RTN_PATH_NULL) {
	
	return $RTN_PATH_NULL;
	
    }

    #
    # Make sure we can cd to and read this directory.
    #
    if(! -x $pdir) {

	return $RTN_DIR_NO_EXECUTE;

    }
    if(! -r $pdir) {

	return $RTN_DIR_UNREADABLE;

    }
      
    #
    # Redy to copy
    #
    if(system("(cd $pdir; find $sname -print | cpio -pdmu  $tpath > /dev/null 2>&1)")) {

	return $RTN_COPY_FAILED;

    }

    return $RTN_COPY_OK;
}



#
# mdep_copy_list
# Inputs: 
#   sdir
#     The directory path that contains the list of files/directories
#   tdir
#     The directory path to copy them to.
#   list 
#     The list of files directories to copy.
# Ouputs:
#   None
# Returns
#   None
# References:
# Modifies:
# Calls:
# Description:
#   Copy all of the files and directories in $list from the $src directory
#   to the $dest directory
#
sub mdep_copy_list {

    local($spath) = shift(@_);          # Source directory path
    local($tpath) = shift(@_);          # Target directory path
    local(@list) = @_;                  # List to copy
    local($object);                     # One of list
    local($tmpname);                    # Temp file name
    local($cpioout);
    local(@cpioerror);
    local($line);


    #
    # Check the arguments
    #
    if($spath eq "") {

	return $RTN_PATH_NULL;

    }
    if($tpath eq "") {

	return $RTN_PATH_NULL;

    }

    #
    # Make sure $sdir and $tdir are directories
    #
    if(! -d $spath) {

	return $RTN_DIR_NOT_DIRECTORY;

    }

    if(! -d $tpath) {

	return  $RTN_DIR_NOT_DIRECTORY;

    }

    #
    # Check permissions
    #
    if(! -r $spath) {

	return $RTN_DIR_UNREADABLE;

    }
    if(! -w $tpath) {

	return $RTN_DIR_NOT_DIRECTORY;

    }

    #
    # Looks good. Do the copy.
    #
    $tmpname = &mdep_get_tmpname();
    unless(open(CPIOIN,">$tmpname")) {

        return $RTN_COPY_FAILED;
    }

    foreach $object (@list) {

        print CPIOIN "$object\n";
    }

    close(CPIOIN);
    $cpioout = &mdep_get_tmpname();
    if(system("(cd $spath; cat $tmpname  | cpio -pdmu $tpath) > $cpioout 2>&1")) {
	unless(open(CPIOOUT,"$cpioout")) {
	    
	    return $RTN_COPY_FAILED;
	}
        @cpioerror = <CPIOOUT>;
	&mdep_logger($MDEP_E_L,"cpio failed. Its output follows...\n");
	while($line = shift(@cpioerror)) {
	    &mdep_logger($MDEP_E_L,$line);
	}
	&mdep_rmfile($cpioout);
        &mdep_rmfile($tmpname);
	return $RTN_COPY_FAILED;

    }
    &mdep_rmfile($tmpname);
    &mdep_rmfile($cpioout);
    return $RTN_COPY_OK;
}


sub mdep_path_equal {

    local($source,$target) = @_;
    local($sparent);
    local($tparent);
    local($si,$ti,$j);
    local($ret_status);
    local($junk1,$junk2);
    local($junk_leaf);
    local($t1,$t2,$b1,$b3);


CLEANUP_PATH_EQUAL: {

    if(!$source || !$target) {

	$ret_status =  0;
        last CLEANUP_PATH_EQUAL;
    }

    if($source eq $target) {
	$ret_status = 1;
        last CLEANUP_PATH_EQUAL;
    }

    $sparent = &mdep_dirname($source);
    $tparent = &mdep_dirname($target);

    ($j,$si,$j,$j,$j,$j,$j,$j,$j,$j,$j,$j,$j) = stat($source);
    ($j,$ti,$j,$j,$j,$j,$j,$j,$j,$j,$j,$j,$j) = stat($target);

    if($si != $ti) {
	$ret_status = 0;
	last CLEANUP_PATH_EQUAL;
    }

    $t1 = $source;
    $t2 = $target;
    while($t1 && $t2) {
        $b1 = &mdep_basename($t1);
        $b2 = &mdep_basename($t2);
	if($b1 ne $b2) {
	    last;
	}
	if((-d $t1) || (-d $t2)) {
	    last;
	}
	$t1 = &mdep_dirname($t1);
	$t2 = &mdep_dirname($t2);

    }

    #
    # One more check - touch a file and see if it can be accessed 
    # by the other path.
    #
    $junk_leaf = "vob_snapshot_tmp.$$";
    $junk1 = $t1.$MDEP_SEP.$junk_leaf;
    $junk2 = $t2.$MDEP_SEP.$junk_leaf;
    
    unless(open(JUNK1,">$junk1")) {
	$ret_status = 0;
        last CLEANUP_PATH_EQUAL;
    }

    close(JUNK1);

    unless(open(JUNK2,"$junk2")) {
	$ret_status = 0;
        last CLEANUP_PATH_EQUAL;
    }
    
    $ret_status = 1;

  } # CLEANUP_PATH_EQUAL
    &mdep_rmfile($junk1);

    return $ret_status;
}

sub mdep_is_locked {

    local($tag) = @_;
    local($status);
    local($ret_status);
    local($tmpfile);

CLEANUP_IS_LOCKED: { # Always return at end of this block.

    if($storage_dir eq "") {

	$ret_status = -1;
	last CLEANUP_IS_LOCKED;
    }
    $tmpfile = &mdep_get_tmpname();
    $status = system(
       "$MDEP_CLEARTOOL lslock vob:$tag > $tmpfile 2>&1");

    if(!$status) {

	#
	# It failed. Try and determine if it was due to lock alread held
        # or another failure.
	#
	unless(open(LOCK_TMP,$tmpfile)) {

	    #
	    # Only thing I can think of is they ran out of file 
	    # descriptors. Return something that says we don't know 
	    # what the state of the lock is.
	    #
	    $ret_status = -1;
	    last CLEANUP_LS_LOCKED;
	}

        if(!grep(/Locked for all users/,@lines = <LOCK_TMP>)) {

	    $ret_status = 0;
        }
	else {

	    $ret_status = 1;
	}
    }
    
  } # CLEANUP_IS_LOCKED Always return here

    close(LOCK_TMP);
    &mdep_rmfile($tmpfile);
    return $ret_status;
}

    
    
#
# mdep_lock_vob
# Inputs:
#   $storage_dir
#     The location of the storage area
#   @exclude
#     A list of users to exclude
# Outputs:
#   None
# Returns:
# References:
#   None
# Modifies:
#   None
# Calls:
#   None
# Description:
#   Lock the storage area $storage_dir. If it can't be locked find out
#   if its because its already locked. Replace and nusers may be specified.
#
sub mdep_lock_vob {

    local(*tag,*storage_dir,*replace,*comment,*excludes) = @_;
    local($excludestr);               # Joined excludes
    local($nusers) = "";              # Foramtted nusers arguments.
    local($status);                   # Return status
    local(@cmdbuf);                   # Buffer to catch mdep_command output.
    local($tmpfile);                  # Put lock command output here
    local($line);                     # Line buffer for parsing tmpfile
    local($doreplace);                # Real replace argument
    local($ret_status);               # Return status

    $ret_status = $RTN_NO_STATUS_SET;

CLEANUP_LOCK_VOB: { # Always return at end of this block.

    #
    # Check inputs
    #
    if($storage_dir eq "") {

	$ret_status = $RTN_BAD_PARAMETERS;
	last CLEANUP_LOCK_VOB;
    }
    if($#excludes >= 0) {

	$excludestr = join(',',@excludes);
	$nusers = '-nusers '.$excludestr;
    }

    if($replace eq $MDEP_NO_REPLACE_LOCK) {

	$doreplace = "";
    }
    else {
	$doreplace = $replace;
    }

    #
    # Attempt the lock catching output. If it failes we parse the output
    # to try and understand why.
    #
    $tmpfile = &mdep_get_tmpname();
    $status = system(
 "$MDEP_CLEARTOOL lock -c \"$comment\" $doreplace $nusers vob:$tag > $tmpfile 2>&1");

    if($status) {

	#
	# It failed. Try and determine if it was due to lock alread held
        # or another failure.
	#
	unless(open(LOCK_TMP,$tmpfile)) {

	    #
	    # Only thing I can think of is they ran out of file 
	    # descriptors. Return something that says we don't know 
	    # what the state of the lock is.
	    #
	    $ret_status = $RTN_LOCK_FAILED;
	    last CLEANUP_LOCK_VOB;
	}

	#
	# Look for the string that says its already locked.
	#
	foreach $line (<LOCK_TMP>) {

	    if($line =~ /.*Lock on VOB database.*/) {
		
		#
		# Yep. It was locked.
		#
		$ret_status = $RTN_LOCK_WAS_LOCKED;
		last CLEANUP_LOCK_VOB;

	    }
	}
	
	#
	# Some other kind of error. Return generic failure.
	#
	$ret_status = $RTN_LOCK_FAILED;
	last CLEANUP_LOCK_VOB;
    }

    $ret_status = $RTN_LOCK_OK;

  } # CLEANUP_LOCK_VOB Always return here

    &mdep_rmfile($tmpfile);
    close(LOCK_TMP);
    return $ret_status;
}

#
# mdep_unlock_vob
# Inputs:
#   $storage_dir
#     The location of the storage area
# Outputs:
#   None
# Returns:
# References:
#   None
# Modifies:
#   None
# Calls:
#   None
# Description:
#   Unock the storage area $storage_dir. If it can't be locked find out
#   if its because its already locked. The user may want to know.
#
sub mdep_unlock_vob {

    local(*tag,*comment) = @_;  # The storage area
    local($status);               # Return status
    local(@cmdbuf);               # Buffer to catch mdep_command output.
    local($tmpfile);              # Put lock command output here
    local($line);                 # Line buffer for parsing tmpfile
    local($ret_status);           # Return status

    $ret_status = $RTN_NO_STATUS_SET;

CLEANUP_UNLOCK_VOB: { # Always return at end of this block.

    #
    # Check inputs
    #
    if($tag eq "") {

	$ret_status = $RTN_BAD_PARAMETERS;
	last CLEANUP_UNLOCK_VOB;
    }

    #
    # Attempt the lock catching output. If it failes we parse the output
    # to try and understand why.
    #
    $tmpfile = &mdep_get_tmpname();
    $status = system(
	   "$MDEP_CLEARTOOL unlock -c \"$comment\" vob:$tag > $tmpfile 2>&1");

    if($status) {

	#
	# It failed. Try and determine if it was due to lock alread unlocked
        # or another failure.
	#
	unless(open(UNLOCK_TMP,$tmpfile)) {

	    #
	    # Only thing I can think of is they ran out of file descriptors.
            # Return something that says we don't know what the state of
	    # the lock is.
	    $ret_status =  $RTN_UNLOCK_FAILED;
	    last CLEANUP_UNLOCK_VOB;
	}

	#
	# Look for the string that says its already locked.
	#
	foreach $line (<UNLOCK_TMP>) {

	    if($line =~ /.*Object is not locked.*/) {
		
		#
		# Yep. It was locked.
		#
		$ret_status = $RTN_LOCK_WAS_UNLOCKED;
		last CLEANUP_UNLOCK_VOB;

	    }
	}

	#
	# Some other kind of failure.
	#
	$ret_status = $RTN_UNLOCK_FAILED;
	last CLEANUP_UNLOCK_VOB;
    }

    $ret_status = $RTN_UNLOCK_OK;

  } # CLEANUP_UNLOCK_VOB Always return here

    close(UNLOCK_TMP);
    &mdep_rmfile($tmpfile);
    return $ret_status;
}


sub mdep_get_vob_ownership {

    local($vob_tag) = @_[0];      # Vob tag
    local($owner) = "";

    if($vob_tag eq "") {

	return "";
    }

    @cmdbuf = &mdep_command("$MDEP_DESCRIBE -long vob:$vob_tag");


    foreach $line (@cmdbuf) {

	chop $line;

	if($line =~ /\s*owner (.*)/) {

	    $owner = $1; last;
	}
    }

    return $owner;
}


sub mdep_set_ownership {

    local($storage_dir) = @_[0];           # Storage dir

    
    if(chown(0,0,$storage_dir) == 1) {

	return $RTN_OK;
    }

    return $RTN_NOT_OK;

}

sub mdep_reset_ownership {

    local($vob_tag) = @_[0];      # Vob tag
    local($storage_dir) = @_[1];  # Storage dir
    local($owner);                 # Uid and group

    $owner =  &mdep_get_vob_ownership($vob_tag);

    if($owner eq "") {

	return $RTN_NOT_OK;
    }

    if(chown((getpwnam($owner))[2,3],$storage_dir) == 1) {

	return $RTN_OK;
    }

    return $RTN_NOT_OK;

}


sub mdep_map_error_type {

    local($estring) = @_[0];      # Error string.

    #
    # On unix they stay the same.
    #
    return $estring;
}




sub mdep_open_log_file {

    local($lpath) = @_[0];        # Path to the log file
    local($ret_status);           # Return status
    local($oldfh);                # Place to save the current file handle

CLEANUP_OPEN_LOG_FILE: { # Always return at end of this block.
    unless(open(LOG_FILE_DESC,">>$lpath")) {
	
	$ret_status =  $RTN_FILE_OPEN_FAILED;
	last CLEANUP_OPEN_LOG_FILE;
    }

    #
    # We want to force out all writes to the log file
    #
    $oldfh = select(LOG_FILE_DESC);$| = 1;select($oldfh);
 
    $ret_status = $RTN_FILE_OPEN_OK;

  } # CLEANUP_OPEN_LOG_FILE Always return here

    return $ret_status;
}


sub mdep_umount {

    local($vob_tag) = @_[0];       # Tag to unmount
    local($status);                # System status
    local($ret_status);            # Return status

CLEANUP_UMOUNT: { # Always return at end of this block.

    if($vob_tag eq "") {

	$ret_status = $RTN_BAD_PARAMETERS;
	last CLEANUP_UMOUNT;
    }

    $status = &system_redirect("$MDEP_CLEARTOOL umount $vob_tag");

    if($status) {

	return $RTN_UMOUNT_FAILED;
	last CLEANUP_UMOUNT;
    }

    return $RTN_UMOUNT_OK;

  } # CLEANUP_UMOUNT Always return here
}

sub mdep_mount {

    local($vob_tag) = @_[0] ;       # Tag to mount
    local($status);                 # System status
    local($ret_status);            # Return status

CLEANUP_MOUNT: { # Always return at end of this block.

    if($vob_tag eq "") {

	$ret_status = $RTN_BAD_PARAMETERS;
	last CLEANUP_MOUNT;
    }

    $status = system("$MDEP_CLEARTOOL mount $vob_tag");

    if($status) {

	return $RTN_MOUNT_FAILED;
	last CLEANUP_MOUNT;
    }

    return $RTN_MOUNT_OK;

  } # CLEANUP_MOUNT Always return here
}
    
sub mdep_real_log_msg {

    local($type) = @_[0];            # Ignored by unis
    local($message) = @_[1];         # Message
    local($ret_status);              # Return status
    local($time);                    # Current time
    local($fstr);                    # General format buffer;

    #
    # Prefix the time to the message and put it out.
    #
    $time = &mdep_get_time();
    $fstr = sprintf("%s %s",$time,$message);
    print LOG_FILE_DESC $fstr;

} 

    

sub mdep_is_tag_valid {
 
    local($vobtag) = @_[0];       # Tag to validate
    local($hostname) = @_[1];
    local($status);               # General status
    local($ret_status);           # Return status
    local(@tags);
    
CLEANUP_IS_TAG_VALID: { # Always return at end of this block.

    if($vobtag eq "") {

	$ret_status = $RTN_NOT_OK;
	last CLEANUP_IS_TAG_VALID;
    }

    $status = &mdep_get_local_tags(*hostname,*tags);
    if($status ne $RTN_OK) {
        $ret_status = $RTN_NOT_OK;
	last CLEANUP_IS_TAG_VALID;
    }

    if(!scalar @tags) {
        return $RTN_NOT_OK;
    }

    $vobtag = quotemeta $vobtag;

    if(!grep(/^$vobtag$/,@tags)) {
	$ret_status = $RTN_NOT_OK;
	last  CLEANUP_IS_TAG_VALID;
    }   

    $ret_status = $RTN_OK;

  } # CLEANUP_IS_TAG_VALID Always return here
}

sub mdep_get_login_id {
 
    local(@cmdbuf);             # Return bufer for mdep_command
    local($line);               # Line buffer for parsing output
    local($id);                 # Id to return
    local($string);
    local(@ids);
    local($uid);

 
 
    $id = "";
 
    @cmdbuf = &mdep_command("$MDEP_GET_LOGIN");
    if(@cmdbuf[0] eq $MDEP_COMMAND_FAILURE) {
        return;
    }
 
    $string = @cmdbuf[0];
 
    @ids = split(' ',$string);
    $uid = @ids[0];
 
    if($uid =~ /uid=(\d*)\((.*)\)/) {
            $id = $2;
    }
 
    return $id;
}

sub mdep_privileged {

    local($myid);

    $myid = &mdep_get_login_id();

    if($myid ne 'root') {

	return 0;
    }
    else {

	return 1;
    }
}
 


$MDEP_LOG_FORMAT              = "%s(%d): %s: %s";
$MDEP_NOTIFY_FORMAT           = "%s: %s";

$MDEP_LOG_FILE                = $MDEP_ATRIA_LOG_DIR.$MDEP_SEP.'snap_log';

#
# mdep_log_notification returns whether it sent anything or
# not to those who are interested.
#
$MDEP_NOTIFY_SENT             = "Notify Sent";
$MDEP_NOTIFY_SENT             = "Notify Not Sent";

#
# mdep_log_msg does likewise
#
#
$MDEP_MSG_LOGGED              = "Message Logged";
$MDEP_MSG_LOGGED              = "Message Not Logged";
 
#
# Whether the log in the var/adm/atria/log directory is open or
# not. 
#
$MDEP_LOG_NOT_OPEN            = 0;
$MDEP_LOG_IS_OPEN             = 1;
$mdep_log_open                =  $MDEP_LOG_NOT_OPEN;




#
# Indicates where notification should be sent at any given time.
# If a vob is being snapped it goes to the notification file for
# that vob. Otherwise it goes to the root notification file. See
# the description for mdep_log_notification
$MDEP_NOTIFY_REP              = 1;
$MDEP_NOTIFY_ROOT             = 2;
$mdep_notify                  = $MDEP_NOTIFY_ROOT;

#
# Only one notification file exists for all activity outside of
# snapshots. It gets created by mdep_init_root_file and is open
# when a snap is not taking place. Otherwise its closed and the
# notification file for the snapping replica is open. Each replica
# gets its own notification file which gets written while that replica
# is being snapped. The notification files are saveand processed when 
# all work for all replicas has completed.
#
$MDEP_ROOT_FILE_IS_OPEN       = 1;
$MDEP_ROOT_FILE_NOT_OPEN      = -1;
$MDEP_REP_FILE_IS_OPEN        = 1;
$MDEP_REP_FILE_NOT_OPEN       = -1;
$mdep_root_file_state         = $MDEP_ROOT_FILE_NOT_OPEN;
$mdep_rep_file_state          = $MDEP_REP_FILE_NOT_OPEN;
$mdep_root_notify_file        = "";
$mdep_rep_notify_file         = "";

# 
# We want each user who expresses an interest in one or more replicas
# on this host to get only one mail message, not one for each replica
# that he is interested in. So, as the snaps are taking place we must
# build a list of $mdep_rep_notify_files for each user, one for each
# replica that user is interested in. The lists are comma seperated
# and are built up in &mdep_init_rep_file. WHen all of the work is
# done each users gets one notification consiting of the concatenation
# of the files on his list. The lists are maintained in an associative
# aray indexed by user name.
#
# %mdep_user_notify_lists
# 

#
# The host conf file initially contains parameters that apply to
# all snaps on the host. The parameters are
# $mdep_notify_program 
#     The program to be used to send notification to users interested
#     in information on snaps.
# $mdep_host_notify_list 
#     A list of users interested in all snaps on this host. This list 
#     is concatenated to the replica specific list obtained from the snap 
#     attribute of the each replica.
# $mdep_confirm_success
#     Send notification of success. 
#
$MDEP_HOST_CONF_FILE          = $MDEP_ATRIA_CONF_DIR.'/snapshot.conf';
# 
# 
#
$mdep_notify_program          = $MDEP_D_NOTIFY_PROGRAM;
$mdep_host_notify_list        = $MDEP_D_NOTIFY_LIST;
$mdep_confirm_success         = $MDEP_D_CONFIRM_SUCCESS;






# 
# Function: mdep_logger_string
# Inputs:
#   $mtype
#     Error type
# Outouts:
#   None
# Returns:
#   Appropriate string
# References:
#   None
# Modifies:
#   None
# Calls:
#   None
# Description:
#   Returns the appropriate message string based on set bits in $mtype.
#  
sub mdep_logger_string {

    local($type)= @_[0];      # Message type information

CLEANUP_LOGGER_STRING: { # Always return at end of this block.

    if($type & $MDEP_ERROR) {

	$ret_status = $MDEP_ERROR_STR;
        last CLEANUP_LOGGER_STRING;
    }
    elsif($type & $MDEP_FATAL) {

	$ret_status = $MDEP_FATAL_STR;
        last CLEANUP_LOGGER_STRING;
    }
    elsif($type & $MDEP_WARN) {

	$ret_status = $MDEP_WARN_STR;
        last CLEANUP_LOGGER_STRING;
    }
    elsif($type & $MDEP_NOTE) {

	$ret_status = $MDEP_NOTE_STR;
        last CLEANUP_LOGGER_STRING;
    }

    $ret_status = $MDEP_UNKNOWN_STR;



  } # CLEANUP_LOGGER_STRING Always return here

    return $ret_status;

}

# 
# Function: mdep_logger
# Inputs:
#   $mtype
#     Error type and routing information
#   $message
#     Message string
# Outouts:
#   None
# Returns:
#   None 
# References:
#   None
# Modifies:
#   None 
# Calls:
#   &mdep_log_msg
#   &mdep_log_notification
# Description:
#   All error messages for the snap module come through here. The first
#   argument contains information about the messages type and where it
#   should go. Basically, on unix errors are of type 'ERROR', WARNING, 
#   and 'NOTE' and go the log file in var/adm/log. An additional type
#   'FATAL' gets converted to a type 'ERROR' with the 'FATAL' string
#   included in the message. On NT messages go through its native 
#   message logging facility which accepts only two types -  failure
#   and success. So, on NT 'FATAL', ERROR', and 'WARNING' messges
#   get mapped to 'FAILURE' and 'NOTE' get mapped to 'SUCCESSS'. The 
#   message itself contains the actual type 'FATAL', 'ERROR', WARNING',
#   or 'NOT' in either case. The message is formatted here and sent
#   the appropiate log via &mdep_log_msg.
#
#   On Unix only...
#   The mtype argument also contains information on wether to send
#   notification to interested users or not. While the program is 
#   running a seperate notification log is maintained for each replica 
#   snap as well as a 'root' log for things that happen outside of a snap.
#   The formatted message may be sent to the notification log, just 
#   the message log described above or both. The formatted message
#   is sent to &mdep_log_notification which decides whether to put it out
#   to the current notification log or not.
#  
sub mdep_logger {

    local($mtype) = @_[0];       # Error type and routing information
    local($message) = @_[1];     # Message
    local($etype);               # Error type string
    local($estring);             # Error type string
    local($lfstr);               # Format string for log file
    local($nfstr);               # Format string for notification file

CLEANUP_LOGGER: { # Always return at end of this block.

    #
    # Format the message. First get the correct string representation
    # for the error level.
    #
    $estring = &mdep_logger_string($mtype);
    
    $lfstr = sprintf($MDEP_LOG_FORMAT,$SNAP_PROGRAM,$$,$estring,$message);
    $nfstr = sprintf($MDEP_NOTIFY_FORMAT,$estring,$message);

    #
    # Send the message off to the logger.
    #
    &mdep_log_msg($mtype,$lfstr);
    #
    # And send notification if needed. mdep_log_notification
    # does whats right.
    #
    &mdep_log_notification($mtype,$nfstr);
    
  } # CLEANUP_LOGGER Always return here

}

# 
# Function: mdep_log_msg
# Inputs:
#   $mtype
#     Error type and routing information
#   $message
#     Message string
# Outouts:
#   None
# Returns:
#   $RTN_BAD_PARAMETERS
#   $MDEP_MSG_LOGGED
#   $MDEP_MSG_NOT_LOGGED
# References:
#   $mdep_log_open
# Modifies:
#   None 
# Calls:
#   &mdep_logger_string
#   &mdep_map_error_type
#   &mdep_log_msg
# Description:
#   This function wraps the call to the machine dependent &mdep_log_msg
#   function. It checks for bad arguments, calls &mdep_map_error_type to
#   map the snap error types to ones the machine type knows about and makes
#   the &mdep_log_msg call.
#  
sub mdep_log_msg {

    local($mtype) = @_[0];        # Message type information
    local($message) = @_[1];      # Message
    local($estring);              # String error type
    local($mapped);               # Mapped estring
    local($ret_status);           # Return status

CLEANUP_LOG_MSG: { # Always return at end of this block.
    #
    # Check the input
    #
    if(($mtype eq "") ||
       ($message eq "")) {

	$ret_status = $RTN_BAD_PARAMETERS;
        last CLEANUP_LOG_MSG;
    }

    #
    # See if it gets logged.
    #
    if(($mtype & $MDEP_LOG) &&
       ($mdep_log_open == $MDEP_LOG_IS_OPEN)) {
	
        $estring = &mdep_logger_string($mtype);
	$mapped = &mdep_map_error_type($estring);
        &mdep_real_log_msg($mapped,$message);
	$ret_status = $MDEP_MSG_LOGGED;
    }
    else {

	$ret_status = $MDEP_MSG_NOT_LOGGED;
    }

  } # CLEANUP_LOG_MSG Always return here

    return $ret_status;
}


# 
# Function: mdep_log_notification
# Inputs:
#   $mtype
#     Error type and routing information
#   $message
#     Message string
# Outouts:
#   None
# Returns:
#   None 
# References:
#   $mdep_notify
#   $mdep_rep_notify_file
#   $mdep_root_notify_file
# Modifies:
#   None
# Calls:
#   None
# Description:
#   Write the message out to the current notification file. If a vob
#   is being snapped the current file will be that vob's notification
#   file, otherwise it will be the root notification file. The name
#   is mesleading. It just means that it goes to all those users in
#   the host wide notification list which usually includes root. 
#
sub mdep_log_notification {

    local($mtype) = @_[0];        # Message type
    local($message) = @_[1];      # Message
    local($ret_status);       
    # Return status

CLEANUP_LOG_NOTIFICATION: { # Always return at end of this block.
    if(($mtype eq "") ||
       ($message eq "")) {

	$res_status = RTN_BAD_PARAMETERS;
	last CLEANUP_LOG_NOTIFICATION;
    }

    #
    # If we should send notification...
    #
    if($mtype & $MDEP_NOTIFY) {

	#
	# ...Check where
	#
	if(($mdep_notify == $MDEP_NOTIFY_REP) &&
	   ($mdep_rep_notify_file ne "") &&
	   ($mdep_rep_file_state == $MDEP_REP_FILE_IS_OPEN)) {
	    print MDEP_REP_NOTIFY_FILE $message;
	    $ret_status = $MDEP_NOTIFY_SENT;
	}
	elsif(($mdep_notify == $MDEP_NOTIFY_ROOT) &&
	      (mdep_root_notify_file ne "") &&
	      ($mdep_root_file_state == $MDEP_ROOT_FILE_IS_OPEN)) {
	    print MDEP_ROOT_NOTIFY_FILE $message;
	    $ret_status = $MDEP_NOTIFY_SENT;
	}
	else {

	    $ret_status = $MDEP_NO_NOTIFY_SENT;
	}
    }
  } # CLEANUP_LOG_NOTIFICATION Always return here
    
    return $ret_status;
}

    
#
# Function: mdep_get_host_parameters
# Inputs: 
#   None
# Outputs: 
#   None
# Returns
#   None
# References: 
#   None
# Modifies:
#   $mdep_notify_program
#   $mdep_host_notify_list
#   $mdep_confirm_success
# Calls: 
#   &mdep_logger   
# Description:
#   Get the host parameters from the conf file. These parameters apply to
#   all snaps on this host. They are described above.
#   
#
sub mdep_get_host_parameters {
    
    local($line);            # Line buffer for reads
    local($fstr);            # General format buffer
    local($ret_status);      # Return status


CLEANUP_GET_HOST_PARAMETERS: { # Always return at end of this block.
    #
    # Default parameter values are already assigned. If we can't open
    # the host conf file leave them but raise a warning.
    #
    unless(open(HOST_CONF_FILE,$MDEP_HOST_CONF_FILE)) {

        #
	# Raise the warning.
	#
	$fstr = sprintf($SNAP_E_CONF_OPEN_FAILED,$MDEP_HOST_CONF_FILE);
	&mdep_logger($MDEP_W_B,$fstr);
	
	#
	# Tell the caller in case they care.
	#
	$ret_status = $RTN_FILE_OPEN_FAILED;
	last CLEANUP_GET_HOST_PARAMETERS;
    } 
    
    #
    # Open worked. Parse the file to get the parameters. Any that aren't
    # found will remain defaulted.
    #
    foreach $line (<HOST_CONF_FILE>) {

	if($line =~ /^\#/) {
	   
	    next;
	}
	
        if($line =~ (/\s*NOTIFICATION_PROGRAM\s*=\s*(\S*)/)) {
	    $mdep_notify_program = $1; next;
	}
	   if($line =~ (/\s*NOTIFICATION_LIST\s*=\s*(\S*)/)) {
	    $mdep_host_notify_list = $1; next;
	}
	if($line =~ (/\s*CONFIRMATION_ON_SUCCESS\s*=\s*(\S*)/)) {
	    $mdep_confirm_success = $1; next;
	}
       }

    $ret_status = $RTN_OK;

  } # CLEANUP_GET_HOST_PARAMETERS Always return here

    close(HOST_CONF_FILE);
    return $ret_status;

}


sub mdep_put_root_on_user_list {

    if(! -s $mdep_root_notify_file) {

	return;
    }

    @users = split(',',$mdep_host_notify_list);
    foreach $user (@users) {
	$mdep_rep_users{$user} .= $mdep_root_notify_file.',';
    }
}

sub mdep_put_on_user_list {

    local($rep_uuid,$notify_file) = @_;
    local(@vlist);
    local(@hlist);
    local(@users);
    local($index);
    local($user);
    local($_);


    #
    # Create a list of all users interested in notification for this
    # replica. This is a concatenation of the $mdep_host_notify_list
    # and those users listed in the replica attribute. The lists are
    # are each comma seperated so concatenate them with a comma in the
    # middle.
    #
    # First put all users on the vob specific list on the final
    # list. Put no user on twice.
    #
    @vlist = split(',',$mdep_rep_notify_list{$rep_uuid});
    @hlist = split(',',$mdep_host_notify_list);
VLOOP:
    while($_ = shift(@vlist)) {
        $index = 0;
	while($user = @users[$index++]) {

	    if($_ eq $user) {
		#
                # The user is already on the list.
                #
                print "skipping\n";
                next VLOOP;
	    }

	}

	push(@users,$_);
    }
    # Then put all users on the host wide list on the final
    # list. Put no user on twice.
    #
HLOOP:
    while($_ = shift(@hlist)) {
        $index = 0;
	while($user = @users[$index++]) {

	    if($_ eq $user) {
		#
                # The user is already on the list.
                #

                next HLOOP;
	    }

	}

	push(@users,$_);
    }

    #
    # If the list is null raise a warning in the log.
    #
    if(!scalar(@users)) {
	my($fstr) = sprintf($SNAP_W_NULL_NOTIFY_LIST,
			    $snap_rep_vob_tag{$rep_uuid});
	&mdep_logger($MDEP_W_L,$fstr);
    }
    #
    # Now that we have a list of users, add this notification file to
    # each users list of file that get sent to that user. These lists
    # just get built with a trailing comma. There will be no leading
    # comma and we don't have to bother stripping the trainling one off
    # now. The last one will get stripped when needed.
    #
    foreach $user (@users) {
	$mdep_rep_users{$user} .= $notify_file.',';
    }
}


#
# Function: mdep_init_rep_file
# Inputs:
#   $rep_uuid
#     Replica uuid of replica to snap
# Output:
#   None
# Returns
#   None
# References:
#   $mdep_root_file_state
#   %mdep_rep_notify_list
#   $mdep_host_notify_list
#   %mdep_rep_vob_tag 
# Modifies:
#   $mdep_rep_file_state
#   $mdep_rep_notify_file
#   $mdep_users_notify_list
#   %mdep_rep_notification_file 
#   $mdep_notify
# Calls:
#   &mdep_close_root_file
#   &mdep_close_rep_file
#   &mdep_get_tmpname
#   &mdep_logger
# Description:
#   Initialize the replicas notification file. Close any notification
#   file currently open first. Open the file, put the file on any user's
#   list who has expressed an interest in this replica's snap. Finally
#   mark the replica's notification file as open and set $mdep_notify to
#   force notification to the replica file.
#   
#    
sub mdep_init_rep_file {

    local($rep_uuid) = @_;         # Replica uuid of snapping repllica
    local($oldhf);

CLEANUP_INIT_REP_FILE: { # Always return at end of this block.
    #
    # If the root file is opwn for some reason close it.
    #
    if($mdep_root_file_state == $MDEP_ROOT_FILE_IS_OPEN) {

	&mdep_close_root_file();
    }

    #
    # If the replica file is open close it.
    #
    if($mdep_rep_file_state = $MDEP_REP_FILE_IS_OPEN) {

	&mdep_close_rep_file();
    }

    #
    # Create and open the file
    #
    $mdep_rep_notify_file = &mdep_get_tmpname();
    unless(open(MDEP_REP_NOTIFY_FILE,">>$mdep_rep_notify_file")) {

	#
	# The open failed. Snaps will proceed but no notification will
        # be sent. The log will be written so hpefully some is watching
        # it.
	#
	&mdep_logger($MDEP_E_L,$SNAP_E_REP_FILE_OPEN_FAILED );
	last CLEANUP_INIT_REP_FILE;
    }
    $oldfh = select(MDEP_REP_NOTIFY_FILE);$| = 1;select($oldfh);
    push(@mdep_notify_files,$mdep_rep_notify_file);
    #
    # Set the file in the  associative array that maps replica_uuid 
    # to file. If we switch to the root file we can get back by looking 
    # up the replica file in this array.
    # 
    $mdep_rep_notification_file{$rep_uuid} = $mdep_rep_notify_file;

    # 
    # And finally set the state of the world. Notification writes will
    # now get logged to this replica's notification file.
    #
    $mdep_rep_file_state = $MDEP_REP_FILE_IS_OPEN;
    $mdep_notify = $MDEP_NOTIFY_REP;
  } # CLEANUP_INIT_REP_FILE Always return here

}


#
# Function: mdep_init_root_file
# Inputs:
#   ome
# Output:
#   None
# Returns
#   None
# References:
#   None
# Modifies:
#   mdep_root_notify_file
#   %snapshot_vob_user
#   $mdep_root_file_state
#   $mdep_notify 
# Calls:
#   &mdep_close_root_file
#   &mdep_get_tmpname
#   &mdep_logger
# Description:
#   Initialize the root's notifification file. Add it to lists of those
#   users in the host notification file. That later file gets opened and
#   parsed by this function.
#   
sub mdep_init_root_file {

    local(@users);                 # List string made into a real list
    local($user);                  # One of users
    local($oldfh);

CLEANUP_INIT_ROOT_FILE: { # Always return at end of this block.
    #
    # If the root file is open for some reason close it.
    #
    if($mdep_root_file_state == $MDEP_ROOT_FILE_IS_OPEN) {

	&mdep_close_rep_file();
    }
    
    #
    # If the root file has already been initialixed do nothing
    #
    if($mdep_root_notify_file ne "") {
	
	last CLEANUP_INIT_ROOT_FILE;
    }

    #
    # Get the name and open the file
    #
    $mdep_root_notify_file = &mdep_get_tmpname();
    unless(open(MDEP_ROOT_NOTIFY_FILE,">$mdep_root_notify_file")) {
	#
	# The open failed. Snaps will proceed but no notification will
        # be sent. The log will be written so hpefully some is watching
        # it.
	#
	&mdep_logger($MDEP_E_L,$SNAP_E_ROOT_FILE_OPEN_FAILED );
	last CLEANUP_INIT_ROOT_FILE;
    }
    $oldfh = select(MDEP_ROOT_NOTIFY_FILE);$| = 1;select($oldfh);
    push(@mdep_notify_files,$mdep_root_notify_file);
    # Unix Only
    # This is a convenient place to read in the host parameters.
    # Once in add this file to the list of notification files sent
    # to users in $mdep_host_notify_list. See the corresponding comment
    # in mdep_init_rep_file for more information on how this mechanism
    # works.
    #
    &mdep_get_host_parameters();

    # 
    # And finally set the state of the world. Notification writes will
    # now get logged to root's notification file.
    #
    $mdep_notify = $MDEP_NOTIFY_ROOT;
    $mdep_root_file_state = $MDEP_ROOT_FILE_IS_OPEN;

  } # CLEANUP_INIT_ROOT_FILE Always return here
}

#
# Function: mdep_reopen_root_file
# Inputs:
#   ome
# Output:
#   None
# Returns
#   None
# References:
#   $mdep_rep_file_state
# Modifies:
#   $mdep_root_file_state
#   $mdep_notify
# Calls:
#   &mdep_close_rep_file
#   &mdep_logger
# Description:
sub mdep_reopen_root_file {

    local($oldfh);

CLEANUP_REOPEN_ROOT_FILE: { # Always return at end of this block.

    #
    # If the root file hasn't been init'd yet do nothing.
    #
    if($mdep_root_notify_file eq "") {

	last CLEANUP_REOPEN_ROOT_FILE;
    }
    #
    # If a replica notification file is open, close it. Switching....
    #
    if($mdep_rep_file_state == $MDEP_REP_FILE_IS_OPEN) {

	&mdep_close_rep_file();
    }

    #
    # If its alredy open do nothing
    #
    if($mdep_root_file_state == $MDEP_ROOT_FILE_IS_OPEN)  {

	last CLEANUP_REOPEN_ROOT_FILE;
    }
    
    #
    # Otherwis open it.
    #
    unless(open(MDEP_ROOT_NOTIFY_FILE,">>$mdep_root_notify_file")) {

	#
	# We may loose notification data but the messages will presumably
        # continue going to the log file. Keep on trucking but log an error.
	#
	&mdep_logger($MDEP_E_L,$SNAP_E_ROOT_REOPEN_FILE_FAILED);
	last CLEANUP_REOPEN_ROOT_FILE;
    }
    $oldfh = select(MDEP_ROOT_NOTIFY_FILE);$| = 1;select($oldfh);

    # 
    # And finally set the state of the world. Notification writes will
    # now get logged to root's notification file.
    #
    $mdep_notify = $MDEP_NOTIFY_ROOT;
    $mdep_root_file_state = $MDEP_ROOT_FILE_IS_OPEN;

  } # CLEANUP_REOPEN_ROOT_FILE Always return here

}



#
# Function: mdep_reopen_rep_file
# Inputs:
#   $file
#     The file to open.
# Output:
#   None
# Returns
#   None
# References:
#   None
# Modifies:
#   %snapshot_vob_user
#   $mdep_root_file_state
#   $mdep_notify 
# Calls:
#   &mdep_close_root_file
#   &mdep_logger
# Description:
#   Reopen the replica notification file given by the $file argument. This
#   would normally be called after all snaps have completed and notification
#   is being sent out.
#
sub mdep_reopen_rep_file {

    local($file) = @_;          # The file to reopen
    local($oldfh);


CLEANUP_REOPEN_REP_FILE: { # Always return at end of this block.

    #
    # Check the argument
    if($file eq "") {
	
	last CLEANUP_REOPEN_REP_FILE;
    }

    #
    # If the root file is open close it. Switching.
    #
    if($mdep_root_file_state == $MDEP_ROOT_FILE_IS_OPEN) {

	&mdep_close_root_file();
    }

    #
    # Otherwis open it.
    #
    unless(open(MDEP_REP_NOTIFY_FILE,">>$file")) {

	#
	# We may loose notification data but the messages will presumably
        # continue going to the log file. Keep on trucking but log an error.
	#
	&mdep_logger($MDEP_E_L,$SNAP_E_REP_REOPEN_FILE_FAILED);
	last CLEANUP_REOPEN_REP_FILE;
    }
    $oldfh = select(MDEP_REP_NOTIFY_FILE);$| = 1;select($oldfh);
    
    # 
    # And finally set the state of the world. Notification writes will
    # now get logged to root's notification file.
    #
    $mdep_rep_notify_file = $file;
    $mdep_notify = $MDEP_NOTIFY_REP;
    $mdep_rep_file_state = $MDEP_REP_FILE_IS_OPEN;
  } # CLEANUP_REOPEN_REP_FILE Always return here
}

#
# Function: mdep_close_rep_file
# Inputs:
#   ome
# Output:
#   None
# Returns
#   None
# References:
#   None
# Modifies:
#   $mdep_rep_notify_file
#   $mdep_rep_file_state
# Calls:
#   None
# Description:
#   Close the replica notification file. Mark its state as closed and call
#   &snapshot_reopen_root_file to switch notification output to the 
#   root file.
#
sub mdep_close_rep_file {

CLEANUP_CLOSE_REP_FILE: { # Always return at end of this block.

    #
    # If the file isn't open do nothing
    #
    if($mdep_rep_file_state == $MDEP_REP_FILE_NOT_OPEN) {

	last CLEANUP_CLOSE_REP_FILE;
    }
    #
    # Close the file
    #
    close(MDEP_REP_NOTIFY_FILE);

    #
    # Mark it as closed. Don't remove it though. 
    #
    $mdep_rep_notify_file = "";
    $mdep_rep_file_state = $MDEP_REP_FILE_NOT_OPEN;
    
    #
    # Switch to the root. 
    #
    &mdep_reopen_root_file();

  } # CLEANUP_CLOSE_REP_FILE Always return here

}

#
# Function: mdep_close_root_file
# Inputs:
#   ome
# Output:
#   None
# Returns
#   None
# References:
#   None
# Modifies:
#   $mdep_root_file_state
# Calls:
#   None
# Description:
#   Close the root file. Should be the last thing called.
#
sub mdep_close_root_file {

CLEANUP_CLOSE_ROOT_FILE: { # Always return at end of this block.

    #
    # If the file isn't open do nothing.
    #
    if($mdep_root_file_state == $MDEP_ROOT_FILE_NOT_OPEN) {

	last CLEANUP_CLOSE_ROOT_FILE;
    }
  
    #
    # Close it. and mark its state. Don't bother to switch to a replica
    # file. Closing the root should/better be the last thing that happens.
    # Marking its kind of silly but......
    #
    close(MDEP_ROOT_NOTIFY_FILE);
    $mdep_root_file_state = $MDEP_ROOT_FILE_NOT_OPEN;

  } # CLEANUP_CLOSE_ROOT_FILE Always return here

}

#
# Function: mdep_notify_user
# Inputs:
#   $user 
#     User getting the notification
#   $list
#     List of notification files to send him
# Output:
#   None
# Returns
#   None
# References:
#   $mdep_notify_program
# Modifies:
#   mdep_root_notify_file
#   %snapshot_vob_user
#   $mdep_root_file_state
#   $mdep_notify 
# Calls:
#   &mdep_close_root_file
#   &mdep_close_rep_file
#   &mdep_get_tmpname
#   &mdep_logger
#   &mdep_rmfile
# Description:
#   Concatenate the list of files into one file and send the result to
#   the user.
#
sub mdep_notify_user {

    local($user) = @_[0];           # The user 
    local($list) = @_[1];           # List of files to send
    local($subject);                # The subject line
    local($program);                # What does the sending
    local(@nfiles);                 # Notification file list on array format
    local($nfile);                  # One of nfiles
    local($tmpfile);                # All the files in @nfiles cat to this
    local($line);                   # Line buffer for reading


CLEANUP_NOTIFY_USER: { # Always return at end of this block.

    #
    # Set the subject. Keep it simple
    #
    $subject = $MDEP_N_NOTIFY_SUBJECT;

    #
    # The notification program
    #
    $program = $mdep_notify_program;

    # 
    # Remove the trailing comma. See how the list is constructed
    # in the mdep_init_rep_file description
    #
    chop($list);

    
    #
    # Close any notification files that may be opened so they
    # get drained properly. We can only log to the log file 
    # from here on out.
    #
    &mdep_close_root_file();
    &mdep_close_rep_file();

     # 
    # Gather all output files in the list into one file
    #
    @nfiles = split(/\,/,$list);
    $tmpfile = &mdep_get_tmpname();
    # 
    # Put them all together
    #
    foreach $nfile (@nfiles) {

	unless(open(OFILE,"$nfile")) {
	    #
	    # Shouldn't happen but you never know.
	    #
	    &mdep_logger($MDEP_E_L,$SNAP_E_OPEN_FOR_SEND_FAILED );
	}

	unless(open(MAIL_FILE,">>$tmpfile")) {
	    
	    &mdep_logger($MDEP_E_L,$SNAP_NOTIFY_CAT_FILE_OPEN_FAILED);
	}
	#
	# Read 'em in and put 'em out
	#
	foreach $line (<OFILE>) {

	    print MAIL_FILE $line;
	}

	#
	# Close this one
	#
	close(OFILE);
        close(MAIL_FILE);
    }

    #
    # Send it.
    #
    system("$program -s \"Snapshot Status\" -f $tmpfile $user");

    

    #
    # Clean upt the concat file
    #
    &mdep_rmfile($tmpfile);

  } # CLEANUP_NOTIFY_USER Always return here

}




#
# Function: mdep_send_notification
# Inputs:
#   None
# Output:
#   None
# Returns
#   None
# References:
#   %mdep_rep_users
# Modifies:
#   None
# Calls:
#   &mdep_logger
#   &mdep_notify_user
# Description:
#   Put together the information for the call to send notification
#   to a particular user, then call &mdep_notify_user.
#
sub mdep_send_notification {

    local($user);             # User who gets notification
    local($list);             # File list to send.
    local($file);
    
CLEANUP_SEND_NOTIFICATION: { # Always return at end of this block.
    #
    # For each user in %mdep_rep_users get the list of replicas 
    # notification files for replicas that that user expressed an in.
    # Call mdep_notify_userwith the user id amd list.
    #

    foreach  $user (keys(%mdep_rep_users)) {
    
	$list = $mdep_rep_users{$user};
	#
	# If the list is null raise a warning in the log file. Otherwise
        # make the mdep_notify_user call with the information.
	#
	if($list eq "") {
	    &mdep_logger($MDEP_W_B,$SNAP_W_NULL_NOTIFY_LIST);
	}
	else {

	    &mdep_notify_user($user,$list);
	}
    }

    #
    # Remove all of the notification files now.
    #
    foreach $file (@mdep_notify_files) {

        &mdep_rmfile($file);
    }

  } # CLEANUP_SEND_NOTIFICATION Always return here
}

sub mdep_check_deferred_del {
 
    local($storage_dir) = @_[0];# Replica storage area
    local($confpath);           # Path to vob_server conf file
    local($line);               # Line buffer for parsing file
    local($ret_status);         # Return status
 
CLEANUP_CHECK_DEFFERED_DELETES: { # Always return at end of this block.
 
    $confpath = $storage_dir.$MDEP_SEP.$MDEP_VOB_SERVER_CONF;
    
    unless(open(VOB_CONF,$confpath)) {

        $ret_status = $RTN_OPEN_FAILED;
        last CLEANUP_CHECK_DEFFERED_DELETES;
    }
     
    $ret_status = $RTN_NOT_SET;
 
    foreach $line (<VOB_CONF>) {
        chop $line;
        if($line =~ /$MDEP_DEFFERED_DEL_PARAMETER=(.*)/) {

            if($1 eq 'yes') {

                $ret_status = $RTN_SET;
                last CLEANUP_CHECK_DEFFERED_DELETES;
            }
        }
    }
 
  } # CLEANUP_CHECK_DEFFERED_DELETES Always return here
 
    close(VOB_CONF);
    return $ret_status;
}

@months = ("Jan", "Feb", "Mar", "Apr", "May", "Jun",
           "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
sub mdep_date_fmt_time_long {

    local($time) = @_;
    local($sec, $min, $hour, $day, $mon, $year);
    local($date_str);


    ($sec, $min, $hour, $day, $mon, $year) = localtime($time);
    $year = $year + 1900;
    $date_str = sprintf("%.2d-%.2d-%.4d.%.2d.%.2d.%.2d",
                        $day, $months[$mon], $year,
                        $hour, $min, $sec);
    return $date_str;
}

sub mdep_log_event  {

}

sub mdep_is_uncname {

    return 0;
}

sub mdep_set_shell {

    $ENV{SHELL} = sh;
}

sub mdep_move_temp_to_dest {

    local($from,$to) = @_;
    local($status) = 0;

    if(!$from || !$to) {
	return 0;
    }
    $status = system("$MDEP_MOVE $from $to");
    return $status;
}


sub mdep_scheduled_for_snap {

    local(*tag,*snap_to) = @_;
    local($count);
    local($tmpname);
    local($ret_status);

CLEANUP_SCHEDULED_FOR_SNAP: {

    if(!$tag) {
	$ret_status = -1;
	last CLEANUP_SCHEDULED_FOR_SNAP;
    }

    $tmpname = &mdep_get_tmpname();
    #
    # Save NLSPATH and set to null for English
    #
    $NLSPATH = $ENV{NLSPATH}; 
    $ENV{NLSPATH} = "";
    $count = system("$MDEP_VOB_SETUP lsvob -long $tag > $tmpname 2>&1");
    #
    # Now restore NLSPATH 
    #
    $ENV{NLSPATH} = $NLSPATH; # Reset NLSPATH
    if($count == 0xff ) {
	$ret_status = -1;
	last CLEANUP_SCHEDULED_FOR_SNAP;
    }
    $count = $count/256;
    if($count == 0) {
	$ret_status = 0;
	last CLEANUP_SCHEDULED_FOR_SNAP;
    }
    elsif($count == 1) {
	unless(open(TMPNAME,$tmpname)) {
	    $ret_status = -1;
	    last CLEANUP_SCHEDULED_FOR_SNAP;
	}
	while(<TMPNAME>) {
	    chop;
	    if(/Snap To                  (.*)/) {
		$snap_to = $1; 
		$ret_status = 1;
		last CLEANUP_SCHEDULED_FOR_SNAP;
	    }
	}
	$ret_status = -1;
        last CLEANUP_SCHEDULED_FOR_SNAP;
    }
    else {
	$ret_status = -1;
	last CLEANUP_SCHEDULED_FOR_SNAP;
    }

  } # CLEANUP_SCHEDULED_FOR_SNAP

  close($tmpname);
  &mdep_rmfile($tmpname);
  return $ret_status;

}    

sub mdep_remove_snap_attribute {

    local($tag,$storage,$who) = @_;
    local($ret_status);
    local($st);
    local($unlocked) = 0;
    local(@excludes);
    local($comment);
    local($replace);
    local($myid);

CLEANUP_REMOVE_SNAP_ATTRIBUTE: {

    if(!$tag || !$storage) {
	$ret_status = 0;
	last CLEANUP_REMOVE_SNAP_ATTRIBUTE;
    }
    
    $st = &mdep_is_locked($tag);

    if($st == -1) {
	$ret_status = 0;
	last CLEANUP_REMOVE_SNAP_ATTRIBUTE;
    }
    if($st == 1) {

	$myid = &mdep_get_login_id();
	@excludes = ("$myid");
        $comment = sprintf(
		  "%s locking for all but %s to remove snap attribute",
		   $who,
		   $myid);
	$replace = $MDEP_REPLACE_LOCK;
	$st = &mdep_lock_vob(*tag,*storage,*replace,*comment,*excludes);

	if($st ne $RTN_LOCK_OK) {
	    $ret_status = 0;
	    last CLEANUP_REMOVE_SNAP_ATTRIBUTE;
	}

	$unlocked++;
    }

    $st = system("$MDEP_VOB_SETUP rmparam $tag > /dev/null 2>&1");

    if($st == 0xff00) {
	$ret_status = 0;
	last CLEANUP_REMOVE_SNAP_ATTRIBUTE;
    }
    $ret_status = 1;
  } # CLEANUP_REMOVE_SNAP_ATTRIBUTE

    if($unlocked) {
	@excludes = ();
        $comment = sprintf("%s relocking for all after removing snap attribute",$who);
	$replace = $MDEP_REPLACE_LOCK;

	&mdep_lock_vob(*tag,*storage,*replace,*comment,*excludes);
    }
    return $ret_status;
}

sub mdep_same_hosts {

# We are on a first name basis here. wjs.

    my($h1,$h2) = @_;
    $h1 =~ s/^([^\.]+)\..+$/$1/;
    $h2 =~ s/^([^\.]+)\..+$/$1/; 
    if($h1 =~ /$h2/i) {
	return 1;
    }
    return 0;
}


